/*
// File:		SmtpCallback.cpp
//
// Version:		mail.it library 1.0
//
// Copyright:	(C) 2007 Dacons LLP.
//
// Bugs:		If you have problems or suggestions, please contact
//				the Online Support at: http://www.dacons.net/support
*/

#include PCH_FILE_NAME
#include "SmtpCallback.hpp"

int
SmtpCallback::OnOperation(
		Emai::SmtpSession& inSession,
		EmaiUint32 inOperationCode
	)
{
	HWND hwnd = NULL;
	EmaiUint32 statSize = sizeof(HWND);
	inSession.GetUserData(SmtpStatusText, &hwnd, statSize);
	CWnd* wnd = CWnd::FromHandle(hwnd);
	CString statusTexts[] = {
			_T("Connecting to server..."),
			_T("Successfully connected to server."),
			_T("Authenticating on server..."),
			_T("Successfully authenticated on server."),
			_T("Introducing sender..."),
			_T("Successfully introduced sender."),
			_T("Sending recipients..."),
			_T("Recipients successfully sent."),
			_T("Sending message data..."),
			_T("Message data successfully sent."),
			_T("Sending NOOP..."),
			_T("NOOP successfully sent."),
			_T("Closing connection."),
			_T("Connection successfully closed.")
	};

	wnd->SetWindowText(statusTexts[inOperationCode]);
	return EmaiErrNoErr;
}

int
SmtpCallback::OnDataSent(
		Emai::SmtpSession& inSession,
		EmaiUint32 inSentSize,
		EmaiUint32 inTotalSize
	)
{
	HWND hwnd = NULL;
	EmaiUint32 size = sizeof(HWND);
	inSession.GetUserData(SmtpPercentText, &hwnd, size);
	CWnd* wnd = CWnd::FromHandle(hwnd);
	int percent = 0;
	int curPercent = (100 * inSentSize) / inTotalSize;
	size = sizeof(EmaiUint32);
	inSession.GetUserData(SmtpCurrentPercent, &percent, size);
	if (percent != curPercent)
	{
		CString message;
		message.Format(_T("%d %%"), curPercent);
		wnd->SetWindowText(message);
		inSession.SetUserData(SmtpCurrentPercent, &curPercent, size);
	}
	return EmaiErrNoErr;
}

int
SmtpCallback::OnServerError(
		Emai::SmtpSession& inSession,
		EmaiConstCharPtr inServerReply,
		EmaiUint32 /*inReplyCode*/
	)
{
	HWND hwnd = NULL;
	EmaiUint32 wndSize = sizeof(HWND);
	inSession.GetUserData(SmtpStatusText, &hwnd, wndSize);
	CWnd* wnd = CWnd::FromHandle(hwnd);
	CString message;
	message.Format(_T("The server error encountered was: %S"), inServerReply);
	wnd->SetWindowText(message);
	return EmaiErrNoErr;
}
