/*!
// @file		SmtpGUIDlg.hpp
//
// @brief		Dialog class
//
// @version		Mailit for C/C++ 1.0
//
// @author		(C) 2007 Dacons LLP.
//
// @bug			If you have problems or suggestions, please contact
//				the Online Support at: http://www.dacons.net/support
*/

#pragma once
#include "afxwin.h"
#include "afxcmn.h"

#include <EmaiMessage.hpp>

/*!
// @class	CSmtpGUIDlg
// @brief	Smtp sample dialog class.
*/
class CSmtpGUIDlg : public CDialog
{
public:
	/*!
	// @brief	Standart constructor
	//
	// @param	pParent - pointer to parent window
	*/
	CSmtpGUIDlg(CWnd* pParent = NULL);

	enum { IDD = IDD_SMTPGUI_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	/*!
	// @brief	Initialize dialog function.
	//
	// @return	initialization result
	*/
	virtual BOOL OnInitDialog();

	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

protected:
	/*!
	// @brief	Choses file using open file dialog.
	//
	// @return	string with file name
	*/
	CString GetFile(void);

	/*!
	// @brief	Formats error messages.
	//
	// @param	inException - reference to exception class
	*/
	void FormatError(Emai::Exception& inException);
 
	/*!
	// @brief	Calls when user clicks on Send button.
	*/
	afx_msg void OnBnClickedButtonSend();

	/*!
	// @brief	Calls when user clicks on Add attachment button.
	*/
	afx_msg void OnBnClickedButtonAdd();

	/*!
	// @brief	Calls when user clicks on delete attachment button.
	*/
	afx_msg void OnBnClickedButtonDelete();

	/*!
	// @brief	Calls when user activates attachment in list.
	*/
	afx_msg void OnLvnItemActivateAttachmentsList(NMHDR *pNMHDR, LRESULT *pResult);

	/*!
	// @brief	Calls when checks attach text checkbox.
	*/
	afx_msg void OnBnClickedCheckAttachText();

	/*!
	// @brief	Calls when checks attach html checkbox.
	*/
	afx_msg void OnBnClickedCheckAttachHtml();

	/*!
	// @brief	Calls when user sets focus on licence textbox.
	*/
	afx_msg void OnEnSetfocusEditLickey();

	/*!
	// @brief	Calls when user kills focus on licence textbox.
	*/
	afx_msg void OnEnKillfocusEditLickey();

	CString mMailServer;
	CString mAccount;
	CString mPassword;
	CString mSenderAddress;
	CString mRecAddress;
	CString mMsgSubject;
	CString mPlainText;
	CString mHtmlText;
	CString mStatusText;
	CString mPerStatus;
	UINT mPort;
	BOOL mUseSsl;
	CComboBox mAuthType;
	CListCtrl mAttachmentsList;
	CEdit mHtmlEdit;
	BOOL mAttachText;
	BOOL mAttachHTML;
	CEdit mPlainTextEdit;
	CStatic mHelpMessage;
	CString mLicenseKey;
};
